"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = require("../index");
const ipfs_pubsub_room_1 = __importDefault(require("ipfs-pubsub-room"));
const dc_logging_1 = require("@daocasino/dc-logging");
const room12 = "02a360faf69c98cbb776ee848ab7e539b0c1266689b6d84366465dab5dc1cc29";
const logger = new dc_logging_1.Logger("tests");
class IService1Impl {
    constructor() {
        this.plus = 2;
    }
    Method1(param1, param2) {
        logger.debug("serv" + param1.name);
        return { result: param1.count + this.plus + param2 };
    }
}
class IService2Impl {
    constructor() {
        this.plus = 2;
    }
    method3() {
        return "m3";
    }
    Method2(params, param2) {
        logger.debug("serv2" + params.name);
        return { result: params.count + this.plus + param2 };
    }
}
const testRawIpfs = async () => {
    const node1 = await index_1.createIpfsNode();
    const node2 = await index_1.createIpfsNode();
    const room2 = ipfs_pubsub_room_1.default(node2, room12, {});
    const room1 = ipfs_pubsub_room_1.default(node1, room12, {})
        .on("error", error => {
        logger.error(error);
    })
        .on("peer joined", id => {
        logger.debug(`peer joined ${id} to ${node1.id}`);
        room2.sendTo(node1.id, "hi from room2");
    })
        .on("message", msg => {
        logger.debug(msg.data.toString());
    });
    room2.on("error", error => {
        logger.error(error);
    });
    room1.broadcast("hi from room 1");
};
const test = async () => {
    const roomProvider1 = await index_1.IpfsTransportProvider.create();
    const roomProvider2 = await index_1.IpfsTransportProvider.create();
    // const peerWaitPromise = roomProvider1.waitForPeer(
    //   roomProvider2.peerId,
    //   room12
    // )
    // const serv1: IService1 = roomProvider2.getRemoteInterface<IService1>(room12)
    roomProvider2.exposeSevice(room12, new IService2Impl());
    const promise = roomProvider1.getRemoteInterface(room12);
    const serv2 = await promise;
    // await new Promise(resolve => setTimeout(resolve, 10000))
    logger.debug("sdjfl");
    const res1 = await serv2.Method2({ count: 1, name: "call serv 2" }, 30);
    logger.debug(res1);
    const res2 = await serv2.method3();
    logger.debug(res2);
    roomProvider2.stopService(room12);
    roomProvider2.destroy();
    roomProvider1.destroy();
};
test();
//# sourceMappingURL=IpfsMessaging.test.js.map