"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const mocha_1 = require("mocha");
const chai_1 = require("chai");
const dc_logging_1 = require("@daocasino/dc-logging");
const IpfsTransportProvider_1 = require("../Ipfs/IpfsTransportProvider");
const log = new dc_logging_1.Logger("Test ipfs transport provider");
mocha_1.describe('IPFS Transport provider test', () => {
    const providers = [];
    const N = 10;
    mocha_1.it(`Create ${N} providers`, async () => {
        for (let i = 0; i < N; i++) {
            const provider = await IpfsTransportProvider_1.IpfsTransportProvider.create();
            const nodeId = provider.getPeerId();
            chai_1.expect(nodeId).to.be.a('string');
            log.debug(`Created #${i} provider: ${nodeId}`);
            providers.push(provider);
        }
    });
    mocha_1.it(`Destroy ${N} providers`, async () => {
        for (const provider of providers) {
            await provider.destroy();
        }
    });
});
//# sourceMappingURL=ipfsTransportProvider.test.js.map