"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const gServices = new Map();
class DirectTransportProvider {
    getRemoteInterface(address) {
        const service = gServices.get(address);
        if (!service)
            throw new Error(`No service registered at address ${address}`);
        return Promise.resolve(service);
    }
    exposeSevice(address, service, isEventEmitter = true) {
        gServices.set(address, service);
    }
    stopService(address) {
        const status = gServices.delete(address);
        return Promise.resolve(status);
    }
    static create() {
        return Promise.resolve(new DirectTransportProvider());
    }
    destroy() {
        return Promise.resolve(gServices.clear());
    }
    async emitRemote(address, peerId, eventName, params) {
        // const room = this._roomsMap.get(address)
        // if (!room) {
        //   throw new Error(`No open room at ${address}`)
        // }
        // const eventMessage: EventMessage = {
        //   id: getId(),
        //   eventName,
        //   params: [params], // TODO: ???
        //   from: this.peerId
        // }
        // try {
        //   await room.sendTo(peerId, JSON.stringify(eventMessage))
        // } catch (error) {
        //   throw error
        // }
    }
}
exports.DirectTransportProvider = DirectTransportProvider;
//# sourceMappingURL=DirectTransportProvider.js.map