import { ResponseMessage, RequestMessage, EventMessage } from "../Interfaces";
export declare const getId: () => number;
export declare class RemoteProxy {
    _subscriptions: Map<string, Set<any>>;
    _requestCallbacks: Map<number, {
        resolve: (data: any) => void;
        reject: (error: string) => void;
    }>;
    constructor();
    getProxy<TRemoteInterface>(sendRequest: (request: RequestMessage) => void, timeout?: number): TRemoteInterface;
    private _handleSubscribe;
    onMessage(message: ResponseMessage | EventMessage): void;
    _onEventMessage(message: EventMessage): void;
    _onRequestResponse(message: ResponseMessage): void;
}
